/*
 * KeySet.hpp
 *
 *  Created on: Oct 20, 2011
 *      Author: heber
 */

#ifndef KEYSET_HPP_
#define KEYSET_HPP_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <set>

// bug in boost/serialization 1.58. set.hpp needs serialization.hpp included before
#include <boost/serialization/serialization.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/set.hpp>

class KeySet : public std::set<int>
{
public:
  KeySet();
  ~KeySet();

  bool operator<(const KeySet &a) const;

  bool ScanBufferIntoKeySet(char *buffer);

private:
  friend class boost::serialization::access;
  // serialization
  template <typename Archive>
  void serialize(Archive& ar, const unsigned int version)
  {
    ar & boost::serialization::base_object< std::set<int> >(*this);
  }
};

typedef std::pair<KeySet::iterator, bool> KeySetTestPair;

#endif /* KEYSET_HPP_ */
